jQuery.noConflict();

((PLUGIN_ID, $) => {
    'use strict';
    const conf = kintone.plugin.app.getConfig(PLUGIN_ID);
    const appId = kintone.app.getId();
    let opTag = '';
    let appFields = '';
    if (conf) {
        // フォーム情報取得
        kintone.api(kintone.api.url('/k/v1/preview/form', true), 'GET', {app: appId}, (resp) => {
            appFields = resp.properties;
            for (let i = 0; i < appFields.length; i++) {
                if (resp.properties[i]['type'] === 'SINGLE_LINE_TEXT') {
                    opTag = $('<option>');
                    opTag.val(appFields[i]['code']);
                    if (conf['folderName'] === appFields[i]['code']) {
                        opTag.prop('selected', true);
                    }
                    opTag.text(appFields[i]['label'] + ' (' + appFields[i]['code'] + ')');
                    opTag.appendTo($('#folder-name'));
                }
                if (resp.properties[i]['type'] === 'SPACER') {
                    opTag = $('<option>');
                    opTag.val(appFields[i]['elementId']);
                    if (conf['listSpace'] === appFields[i]['code']) {
                        opTag.prop('selected', true);
                    }
                    opTag.text(appFields[i]['elementId']);
                    opTag.appendTo($('#file-list-display'));
                }
                if (resp.properties[i]['type'] === 'MULTI_LINE_TEXT') {
                    opTag = $('<option>');
                    opTag.val(appFields[i]['code']);
                    if (conf['listSaveField'] === resp.properties[i]['code']) {
                        opTag.prop('selected', true);
                    }
                    opTag.text(appFields[i]['label'] + '(' + appFields[i]['code'] + ')');
                    opTag.appendTo($('#file-list-save'));
                }
            }
            if (conf['checkFrag'] === 'YES') {
                $('#checkbox-0').prop('checked', true);
            }
        });
    } else {
        // フォーム情報取得
        kintone.api(kintone.api.url('/k/v1/preview/form', true), 'GET', {app: appId}, function(resp) {
            appFields = resp.properties;
            for (let i = 0; i < appFields.length; i++) {
                if (resp.properties[i]['type'] === 'SINGLE_LINE_TEXT') {
                    opTag = $('<option>');
                    opTag.val(appFields[i]['code']);
                    opTag.text(appFields[i]['label'] + ' (' + appFields[i]['code'] + ')');
                    opTag.appendTo($('#folder-name'));
                }
                if (resp.properties[i]['type'] === 'SPACER') {
                    opTag = $('<option>');
                    opTag.val(appFields[i]['elementId']);
                    opTag.text(appFields[i]['elementId']);
                    opTag.appendTo($('#file-list-display'));
                }
                if (resp.properties[i]['type'] === 'MULTI_LINE_TEXT') {
                    opTag = $('<option>');
                    opTag.val(appFields[i]['code']);
                    opTag.text(appFields[i]['label'] + ' (' + appFields[i]['code'] + ')');
                    opTag.appendTo($('#file-list-save'));
                }
            }
        });
    }
    // 保存ボタンの処理
    $('#submit').click(function() {
        const config = {};
        const folderName = $('select[id="folder-name"]').val();
        const spaceCode = $('select[id="file-list-display"]').val();
        const saveCode = $('select[id="file-list-save"]').val();
        let checkFrag = 'NO';
        if ($('#checkbox-0').prop('checked')) {
            checkFrag = 'YES';
        }
        if (!spaceCode || !saveCode || !folderName) {
            alert('必須項目が選択されていません');
            return;
        }
        config['folderName'] = folderName;
        config['listSpace'] = spaceCode;
        config['listSaveField'] = saveCode;
        config['checkFrag'] = checkFrag;
        kintone.plugin.app.setConfig(config);
    });
    // 「キャンセル」ボタン押下時の処理
    $('#cancel').click(function() {
        history.back();
    });
})(kintone.$PLUGIN_ID, jQuery);
