jQuery.noConflict();
(($) => {
    'use strict';
    // クライアント情報
    const clientInfo = {
        'provider': 'DROPBOX',
        'client': 'sr9qnwe36zf15ov'
    };
    // 認証リクエスト
    const authenticate = () => {
        return new kintone.Promise((resolve, reject) => {
            kintone.oauth.redirectToAuthenticate(clientInfo, window.location.href);
            reject();
        });
    }
    // 認証クリア
    const clearAccessToken = () => {
        kintone.oauth.clearAccessToken(clientInfo, () => {
            window.location.reload();
        });
        return new kintone.Promise((resolve, reject) => {
            reject();
        });
    }
    // doropboxにリクエスト
    const requestDropBox2 = (url, method, opt_data) => {
        if (kintone.oauth.hasAccessToken(clientInfo)) {
            const reqUrl = 'https://api.dropbox.com/2' + url;
            const data = opt_data || {};
            const header = {'Content-Type': 'application/json'};
            return kintone.oauth.proxy(clientInfo, reqUrl, method, header, data).then((resp) => {
                return JSON.parse(resp[0]);
            }).catch((error) => {
                return clearAccessToken();
            });
        }
        return authenticate();

    }

    // スピナーを動作させる関数
    const showSpinner = () => {
        if ($('.kintone-spinner').length === 0) {
            const spin_div = $('<div id ="kintone-spin" class="kintone-spinner">'
                            + '<div align="center"><B>Now Loading</B></div></div>');
            const spin_bg_div = $('<div id ="kintone-spin-bg" class="kintone-spinner"></div>');
            $(document.body).append(spin_div, spin_bg_div);
            $(spin_div).css({
                'position': 'fixed',
                'top': '50%',
                'left': '50%',
                'z-index': '200',
                'background-color': '#fff',
                'padding': '20px',
                '-moz-border-radius': '4px',
                '-webkit-border-radius': '4px',
                'border-radius': '1px'
            });
            $(spin_bg_div).css({
                'position': 'fixed',
                'top': '0px',
                'left': '0px',
                'z-index': '100',
                'width': '100%',
                'height': '100%',
                'background-color': '#000',
                'opacity': '0.5',
                'filter': 'alpha(opacity=50)',
                '-ms-filter': 'alpha(opacity=50)'
            });
            const opts = {
                'color': '#000'
            };
            new Spinner(opts).spin(document.getElementById('kintone-spin'));
        }
        $('.kintone-spinner').show();
    }
    // スピナーを停止させる関数
    const hideSpinner = () => {
        $('.kintone-spinner').hide();
    }
    // ボタン作成関数
    const createBtn = (innerStr, btnID, btnClass) => {
        const buttonClass = btnClass || '';
        const btnTemp = $('<BUTTON></BUTTON>', {
            id: btnID,
            class: buttonClass
        }).html(innerStr);
        return btnTemp;
    }
    // HTMLエスケープ
    const escapeHtml = (str) => {
        let tmpStr = str;
        tmpStr = tmpStr.replace(/&/g, '&amp;');
        tmpStr = tmpStr.replace(/</g, '&lt;');
        tmpStr = tmpStr.replace(/>/g, '&gt;');
        tmpStr = tmpStr.replace(/"/g, '&quot;');
        tmpStr = tmpStr.replace(/'/g, '&#39;');
        return tmpStr;
    }
    window.klib = window.klib || {};
    window.klib.clientInfo = clientInfo;
    window.klib.authenticate = authenticate;
    window.klib.clearAccessToken = clearAccessToken;
    window.klib.requestDropBox2 = requestDropBox2;
    window.klib.showSpinner = showSpinner;
    window.klib.hideSpinner = hideSpinner;
    window.klib.createBtn = createBtn;
    window.klib.escapeHtml = escapeHtml;
})(jQuery);
